{Application 'SUPER_MENU' logic file generated by CSPro }
PROC GLOBAL 
Set explicit;

{ Variables de travail -- contrle de la longueur des champs donta besoin }

alpha(32) CSPro;						{ Repertoire d'execution de CSPro}
alpha(26)  proj;						{ Nom  du repertoire project }
alpha(40)  cmapp, deapp, edapp, exapp, 
          gpapp, scapp, dic;			{ Noms des applications et des repertoires }
alpha(16) clusterapp;
alpha(20) printapp;
alpha(8)  opid;							{ ID de l'operateur }
alpha(90)  floppy;						{ !!! RESEAU !!! Rassurez vous que la longueur du chemin de transfert de donnes est importante }
alpha(2)  wrkdrv; 						{ Longueur du disque dur o stocker les donnes, e.g. "C:" }
alpha(40) wrkprj, backup, expdir, 
      final, raw, veri, xdir;     	    { Divers repertoires }
alpha(40)  dicts, entry, super;         { Divers noms pour repertoires DICTS, SAISIE, SUPER }
alpha(3)  xcluster;                     { !!! CLUSTER !!! make sure length of cluster number is correct }
alpha(2)  fcodes;                       { codes de fichier - M = Principal, V = Verification }
alpha(2)  hcodes;                       { code pour fichier de donnes mnage }
alpha(1)  frstrun;			            { premier tour du programme d'dition }


numeric always, choice, chkok, noyes, err, docopy, t;
numeric i, maxclusternumber, startpos, dd, dr, de, ss, valid;

file pfffile mdata vdata wdata datacopy alldata jstone dirname;

{ ---------------------------------------------------------------------------- }

function chkdir()
  setfile(dirname,xdir);
  if fileexist(xdir) <> 1 then
    errmsg("Directoire %s n'existe pas",xdir);
    stop(-1);
  endif;
end;

function chkexist(mychoice)
  chkok = 1;
  if mychoice = 4 then { si vrification des donnes }
    { !!! RESEAUK !!! change le contenu du message si usage du rseau }
    errmsg("*** Copie des donnes contenant la verification dans l'unite %s",floppy);
    setfile(vdata,concat(strip(floppy), "\",hcodes, xcluster, "V", ".DAT"));
    if !fileexist(wdata) then { donnes de premire saisie n'existe pas dans le repertoire RAW }
      errmsg("Donnees brutes de la ZD %s n'existe pas --- utiliser l'option %s d'abord",xcluster,"A");
      chkok = 0;
    elseif !fileexist(vdata) then { donnes en verification n'existent pas }
      { !!! RESEAUK !!! change le contenu du message si usage du rseau }
      errmsg("Verification donnees de la ZD %s n'est pas dans le repertoire",xcluster);
      chkok = 0;
    endif;
  elseif mychoice = 5 then { if backing up raw data }
    if !fileexist(wdata) then { donnes de premire saisie n'existe pas dans le repertoire RAW  }
      errmsg("Fichier de donnees brutes de la ZD %s n'existe pas",xcluster);
      chkok = 0;
    endif;
  elseif mychoice in 7,8,9 then { si utilisation de donnes brutes }
    if !fileexist(wdata) then { donnes brutes n'existent pas }
      errmsg("Fichier donnees brutes de la ZD %s n'existe pas",xcluster);
      chkok = 0;
    endif;
  endif;
  chkexist = chkok;
end;

function genpff(mychoice)
  if mychoice = 3 then { structure check }
    setfile(pfffile,concat(strip(wrkprj), "\", strip(super), "\", strip(scapp), ".pff"));
    filecreate(pfffile);
    filewrite(pfffile, "[Run Information]");
    filewrite(pfffile, "Version=CSPro 4.0");
    filewrite(pfffile, "AppType=Batch");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Files]");
    filewrite(pfffile, "Application=.\check.bch");
    filewrite(pfffile, concat("InputData=", strip(raw), "\", hcodes, xcluster,"S", ".DAT"));
    filewrite(pfffile, "Listing=.\check.lst");
    filewrite(pfffile, "");
    filewrite(pfffile, "[ExternalFiles]");
    filewrite(pfffile, "Cluster_tracking_dict=.\SUIVI_ZD.dat");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Parameters]");
    filewrite(pfffile, "ViewListing=Always");
  elseif mychoice = 4 then { verification }
    setfile(pfffile,concat(strip(wrkprj), "\", strip(super), "\", strip(cmapp), ".cmp.pff"));
    filecreate(pfffile);
    filewrite(pfffile, "[Run Information]");
    filewrite(pfffile, "Version=CSPro 4.0");
    filewrite(pfffile, "AppType=COMPARE");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Files]");
    filewrite(pfffile, "Application=.\COMPARE.cmp");
    filewrite(pfffile, concat("InputData=", strip(raw), "\", hcodes, xcluster,"S", ".DAT"));
    filewrite(pfffile, "Listing=.\COMPARE.cmp.lst");
    filewrite(pfffile, concat("ReferenceData=", strip(floppy), "\", hcodes, xcluster,"V", ".DAT"));
    filewrite(pfffile, "");
    filewrite(pfffile, "[Parameters]");
    filewrite(pfffile, "ViewListing=Always");
  elseif mychoice = 7 then { editing }
  	noyes = accept("Premier tour du programme d'edition pour la ZD","Non","Oui");
  	frstrun = edit("9",noyes-1);
    setfile(pfffile,concat(strip(wrkprj), "\", strip(super), "\", strip(edapp), ".pff"));
    filecreate(pfffile);
    filewrite(pfffile, "[Run Information]");
    filewrite(pfffile, "Version=CSPro 4.0");
    filewrite(pfffile, "AppType=Batch");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Files]");
    filewrite(pfffile, "Application=.\APUREMENT.bch");
    filewrite(pfffile, concat("InputData=", strip(raw), "\", hcodes, xcluster,"S", ".DAT"));
    filewrite(pfffile, "Listing=.\apurement.lst");
    filewrite(pfffile, "");
    filewrite(pfffile, "[ExternalFiles]");
    filewrite(pfffile, "");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Parameters]");
    filewrite(pfffile, "ViewListing=Always");
    filewrite(pfffile, concat("Parameter=",frstrun));
  elseif mychoice = 8 then { data entry }
    setfile(pfffile,concat(strip(wrkprj), "\", strip(entry), "\", strip(deapp), ".pff"));
    filecreate(pfffile);
    filewrite(pfffile, "[Run Information]");
    filewrite(pfffile, "Version=CSPro 4.0");
    filewrite(pfffile, "AppType=Entry");
    filewrite(pfffile, "");
    filewrite(pfffile, "[DataEntryInit]");
    filewrite(pfffile, concat("OperatorID=", strip(opid)));
    filewrite(pfffile, "Lock=Add, Verify");
    filewrite(pfffile, "Fullscreen=No");
    filewrite(pfffile, "NoFileOpen=Yes");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Files]");
    filewrite(pfffile, concat("Application=", strip(wrkprj), "\", strip(entry), "\", strip(deapp), ".ent"));
    filewrite(pfffile, concat("InputData=", strip(raw), "\", hcodes, xcluster,"S", ".DAT"));
    filewrite(pfffile, "");
     filewrite(pfffile, "[ExternalFiles]");
     filewrite(pfffile, "");
    filewrite(pfffile, "[Parameters]");
    filewrite(pfffile, concat("Parameter=", xcluster));
  elseif mychoice = 11 then { export to SPSS }
    setfile(pfffile,concat(strip(wrkprj), "\", strip(expdir), "\", strip(exapp), ".pff"));
    filecreate(pfffile);
    filewrite(pfffile, "[Run Information]");
    filewrite(pfffile, "Version=CSPro 4.0");
    filewrite(pfffile, "AppType=Batch");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Files]");
    filewrite(pfffile, "Application=..\export\export.bch");
    filewrite(pfffile, concat("InputData=", strip(final), "\ARTMEN.dat"));
    filewrite(pfffile, "Listing=..\export\export.lst");
    filewrite(pfffile, "");
    filewrite(pfffile, "[UserFiles]");
    filewrite(pfffile, "ARTMEN    =..\..\SPSS\ARTMEN.DAT");
    filewrite(pfffile, "ARTIND    =..\..\SPSS\ARTIND.DAT"); 
    filewrite(pfffile, "");
    filewrite(pfffile, "[Parameters]");
    filewrite(pfffile, "ViewListing=Always");
  elseif mychoice = 14 then { print cluster tracking info check }
    setfile(pfffile,concat(strip(wrkprj), "\", strip(super), "\", strip(printapp), ".pff"));
    filecreate(pfffile);
    filewrite(pfffile, "[Run Information]");
    filewrite(pfffile, "Version=CSPro 4.0");
    filewrite(pfffile, "AppType=Batch");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Files]");
    filewrite(pfffile, "Application=.\print_tracking_info.bch");
    filewrite(pfffile, concat("InputData=", strip(wrkprj), "\", strip(super), "\", strip(clusterapp), ".DAT"));
    filewrite(pfffile, "Listing=.\print_tracking_info.lst");
    filewrite(pfffile, "");
    filewrite(pfffile, "[Parameters]");
    filewrite(pfffile, concat("Parameter=", xcluster));
    filewrite(pfffile, "ViewListing=Always");
  endif;
  
  close(pfffile);
end;

function runpff(mychoice);
  if mychoice = 1 then { saisie des informations sur la ZD }
    Execsystem(concat('"', strip(cspro), '\CSEntry.exe" ',
                      strip(wrkprj), "\", strip(super), "\", strip(clusterapp), '.pff'),
               maximized,wait);
  elseif mychoice = 3 then { contrle de la structure }
    { Using single quotes instad of double quotes as double quotes are needed in the string generated }
    Execsystem(concat('"', strip(cspro), '\CSBatch.exe" ',
                      strip(wrkprj), "\", strip(super), "\", strip(scapp), '.pff'),
               maximized,wait);
  elseif mychoice = 4 then { verification }
    Execsystem(concat('"', strip(cspro), '\CSDiff.exe" ',
                      strip(wrkprj), "\", strip(super), "\", strip(cmapp), '.cmp.pff'),
               maximized,wait);
    t = accept("Verification complete?", "1 Oui", "2 Non");
    if t = 1 then
    	tcluster = ecluster;
		t = loadcase(Cluster_tracking_dict, tcluster);
	    if !t then 
	    	{ do nothing  }
			errmsg("Controle d'informations de la ZD non saisie");
		else
			TVERI = sysdate("DDMMYYYY");
		    t = writecase(Cluster_tracking_dict, tcluster);
		    close(Cluster_tracking_dict);
    	endif;	
    endif;
  elseif mychoice = 7 then { edition }
    if noyes = 1 | noyes = 2 then { si l'utilisateur n'a pas appuy sue cancel pour accepter le menu }
      Execsystem(concat('"', strip(cspro), '\CSBatch.exe" ',
                        strip(wrkprj), "\", strip(super), "\", strip(edapp), '.pff'),
                 maximized,wait);
	  t = accept("Edition complete?", "1 Oui", "2 Non");
      if t = 1 then
    	tcluster = ecluster;
		t = loadcase(Cluster_tracking_dict, tcluster);
	    if !t then 
	      { do nothing }
		  errmsg("Controle d'informations de la ZD non saisie");
		else
		  TEDIT = sysdate("DDMMYYYY");
		  t = writecase(Cluster_tracking_dict, tcluster);
		  close(Cluster_tracking_dict);
      	endif;	
      endif;
    endif;

  elseif mychoice = 8 then { saisie des donnes }
    Execsystem(concat('"', strip(cspro), '\CSEntry.exe" ',
                      strip(wrkprj), "\", strip(entry), "\", strip(deapp), '.pff'),
               maximized,wait);
  elseif mychoice = 11 then { exportation vers SPSS }
    Execsystem(concat('"', strip(cspro), '\CSBatch.exe" ',
                      strip(wrkprj), "\", strip(expdir), "\", strip(exapp), '.pff'),
               maximized,wait);
  elseif mychoice = 14 then { Impression des info sur le suivi de la ZD }
    { Using single quotes instad of double quotes as double quotes are needed in the string generated }
    Execsystem(concat('"', strip(cspro), '\CSBatch.exe" ',
                      strip(wrkprj), "\", strip(super), "\", strip(printapp), '.pff'),
               maximized,wait);
  endif;
end;

function csrun(mychoice)
  if chkexist(mychoice) then
    genpff(mychoice);
    runpff(mychoice);
  endif;
end;

function transfer(mychoice)
  if mychoice = 3 or mychoice = 4 then { if checking structure }
    if fileexist(wdata) then
      docopy = accept("Recopier le fichier de la saisie principale?","Non","Oui")-1;
    else
      docopy = 1;
    endif;
    if docopy = 1 then
      { !!! NETWORK !!! remove message if using a network }
      errmsg("*** Copie des donnees principales dans l'unite %s",floppy);
      setfile(mdata,concat(strip(floppy), "\",hcodes, xcluster, "S", ".DAT"));
      if !fileexist(mdata) then { if main data not on diskette }
        { !!! NETWORK !!! change wording of message if using a network }
        errmsg("Saisie principale de la ZD %s n'existe pas dans ce repertoire",xcluster);
        chkok = 0;
      else
        filecopy(mdata,wdata);
        errmsg("Saisie principale de la ZD %s copiee dans le directoire",xcluster);
        if mychoice = 4 then 
          chkexist(4);
        endif;
        genpff(mychoice);
        runpff(mychoice);
      endif;
    elseif docopy = 0 then { docopy can equal -1 if user hits cancel }
      if mychoice = 4 then 
        chkexist(4);
      endif;
      genpff(mychoice);
      runpff(mychoice);
    endif;
  elseif mychoice = 5 then
    if chkexist(mychoice) then
      { copy the data to the backup directory }
      setfile(datacopy,concat(strip(backup), "\",hcodes,xcluster, "S",  ".dat"));
      filecopy(wdata,datacopy);
      errmsg("Saisie principale de la ZD %s copiee dans le directoire backup",xcluster);

	  { Write cluster tracking info }
	  tcluster = ecluster;
	  t = loadcase(Cluster_tracking_dict, tcluster);
	  if !t then 
	   	{ do nothing   }
		errmsg("Controle d'information de la ZD non saisie");
	  else
		TRAW = sysdate("DDMMYYYY");
	    t = writecase(Cluster_tracking_dict, tcluster);
	    close(Cluster_tracking_dict);
	  endif;	
    endif;
  elseif mychoice = 9 then
    if chkexist(mychoice) then
      { copy the data to the final directory }
      setfile(datacopy,concat(strip(final), "\",hcodes,xcluster, "S",  ".dat"));
      filecopy(wdata,datacopy);
      errmsg("Saisie principale de la ZD %s copiee dans le directoire final",xcluster);
	  { Write cluster tracking info }
      tcluster = ecluster;
	  t = loadcase(Cluster_tracking_dict, tcluster);
	  if !t then 
	   	{ do nothing }
		errmsg("Controle d'informations de la ZD non saisie");
	  else
		TFINAL = sysdate("DDMMYYYY");
	    t = writecase(Cluster_tracking_dict, tcluster);
	    close(Cluster_tracking_dict);
	  endif;	
    endif;
  elseif mychoice = 11 then
    { concatonate the cluster data }
    setfile(alldata,concat(strip(final), "\ARTMEN.dat"));
    fileconcat(alldata,concat(strip(final),"\",hcodes,"*S.dat"));
    csrun(mychoice);
  endif;
end;

PROC SUPER_MENU_FF

Preproc
{ repertoires  }
{ \EESI_2009                  repertoire principal du masque}
{ \EESI_2009\BACKUP           repertoire pour sauvagrde des donnes brutes   }
{ \EESI_2009\DICTIONNAIRE     repertoire pour les dictionnaires              }
{ \EESI_2009\SAISIE           repertoire pour les programmes de saisie       }
{ \EESI_2009\EXPORT           repertoire pour les programmes d'exportation   }
{ \EESI_2009\FINAL            repertoire pour les donnes finales            }
{ \EESI_2009\RAW              repertoire pour donnes brutes RAW             }


CSPro="C:\Program Files\CSPro 4.0"; { CSPRO directory }
proj="ART\MASQUEMEN";			{ Repertoire projet }
cmapp="COMPARE";					{ Nom de l'application du compare }
deapp="ARTMEN";					{ Nom application de saisie }
edapp="APUREMENT";					{ Nom de l'application d'dition }
exapp="EXPORT";						{ Nom de l'application d'exportation }
gpapp="GPSENTRY";					{ GPS application name }
scapp="CHECK";						{ Nom de l'application name de contrle de la structure }
clusterapp="SUIVI_ZD";		        { Nom de l'application pour la saisie des info sur la ZD }
printapp="PRINT_TRACKING_INFO";		{ Nom de l'application pour la saisie des info sur la ZD }
dic="DicoMenage";					{ Nom du dictionnaire }
floppy="C:\PartageARTMEN";		{ !!! RESEAU !!! Repertoire partag }
fcodes = "SV";						{ Code de fichier - M = 1re saisie , V = 2me saisie) }
hcodes = "ZD";
maxclusternumber = 756;				{ !!! ZD !!! plage des valeurs possibles }
wrkdrv="C:";						{ Disque dur utilis }
wrkprj=concat(strip(wrkdrv), "\", PROJ);

raw=concat(strip(wrkprj), "\RAW");			    { Repertoire Raw }
backup=concat(strip(wrkprj), "\SAUVEGARDE");	{ Repertoire sauvegarde donnes brutes }
final=concat(strip(wrkprj), "\FINAL");		    { Repertoire donnes finales }
dicts="DICTIONNAIRE";							{ Dictionnaires }
entry="SAISIE";								    { Repertoire application de saisie }
expdir="EXPORT";							    { Export }
super="CONTROLE";							    { Repertoire des applications du superviseur }


{ Contrle de l'existence des repertoires dont a besoin }
xdir = wrkprj; chkdir();
xdir = concat(strip(wrkprj), "\", strip(dicts)); chkdir();
xdir = concat(strip(wrkprj), "\", strip(entry)); chkdir();
xdir = concat(strip(wrkprj), "\", strip(expdir)); chkdir();
{xdir = concat(strip(wrkprj), "\", strip(gps)); chkdir();}
xdir = concat(strip(wrkprj), "\", strip(super)); chkdir();
xdir = backup; chkdir();
xdir = final; chkdir();
xdir = raw; chkdir();

{ creation du fichier de nom justone }
setfile(jstone,concat(strip(wrkprj),"\justone.txt"));
{ Contrlez s'il y a pas une autre session de CSPro lanc au mme moment }
if fileexist(jstone) then
  errmsg("Il y'a une autre session de saisie en cours ou l'ordinateur s'est plante en cours de session");
  if accept("Reinitialiser","Oui","Non") = 1 then
    filedelete(jstone)
  else
    stop(-1);
  endif;
endif;
{ crer le fichier justone [it is deleted when option 11, quit, is selected by the DE operator }
setfile(jstone,concat(strip(wrkprj),"\justone.txt"),create);

PROC SUPER_MENU_QUEST_FORM
{Application 'SUPER_MENU' logic file generated by CSPro }
PROC ECLUSTER

{ !!! ZD !!! donner la liste valide des ZD }
recode ecluster => err;
        001-756 => 0;
                => 1;
endrecode;
if err then
  display("Numero de ZD invalide");
  reenter;
endif;

{ !!! ZD !!! check length of edit pattern matches length of largest cluster number }
xcluster = edit("999",$);
{ Spcifier le chemin du repertoire RAW }
setfile(wdata,concat(strip(raw), "\",hcodes, xcluster, "S", ".DAT"));
{ Spcifier le nom du fichier qui permet de se rassurer qu'une seule version de CSPro est en cours }
setfile(jstone,concat(strip(wrkprj),"\justone.txt"));
{ Spcifier le nom du repertoire projet }
setfile(dirname,wrkprj);
close(dirname);

always = 1;
while always do   { boucle }
  { Obtenir l'option slectionne }
{{US}
  choice = accept("Supervisor menu options",
                  "T Enter cluster tracking information...........T",
                  "------------------------------------------------",
                  "A Check data structure.........................A",
                  "B Verify the data..............................B",
                  "C Backup the raw data..........................C",
                  "------------------------------------------------",
                  "D Run Secondary Editing Program................D",
                  "E Modify the data..............................E",
                  "F Backup the final data........................F",
                  "------------------------------------------------",
                  "G Export the data to SPSS (all clusters).......G",
                  "------------------------------------------------",
                  "N New cluster number...........................N",
                  "V View cluster tracking information............V",
                  "Q Quit.........................................Q");
{US}}
{+FR}
  choice = accept("Options Menu Superviseur",
                  "T Entrer information controle ZD...............T",
                  "------------------------------------------------",
                  "A Controle structure des donnees...............A",
                  "B Verification des donnees.....................B",
                  "C Sauvegarde donnees brutes....................C",
                  "------------------------------------------------",
                  "D Tourner le programme d'edition secondaire....D",
                  "E Modifier les donnees.........................E",
                  "F Sauvegarde donnees finales...................F",
                  "------------------------------------------------",
                  "G Convertion donnees en SPSS (Toutes les ZD)...G",
                  "------------------------------------------------",
                  "N Nouveau numero ZD.............................N",
                  "V Revoir informations controle ZD...............V",
                  "Q Quitter......................................Q");
{FR+}

  if choice = 1 then
    tcluster = ecluster;
    t = loadcase(Cluster_tracking_dict, tcluster);
        { si impossible de charger la cas, initialiser le fichier de donnes }
    if !t then 
      display("Initialisation fichier. SVP appuiyer sur ok, et attender");
      { Initialiser tous les enregistrements  zero }
      TRECV = 0; TNUMHHSEL = 0; TNUMHHCOMP = 0; TNUMHHQUEST = 0;
      TNUMINQUEST = 0; TNUMINREMP = 0; TNUMUPQUEST = 0; TNUMUPREMP= 0;
      TENTRYOPID = 0; TENTRY = 0; TVENTRYOPID = 0; TVENTRY = 0; TVERI = 0; 
      TCHECK = 0; TRAW = 0; TEDIT = 0; TFINAL = 0; 
      i = 1;
      { Pour chaque ZD }
      open(Cluster_tracking_dict);
      while i < maxclusternumber do
        { !!! ZD !!! vrifier le numro de la ZD }
        recode i       => valid;
               001-756 => 1;     {!!! Liste valide des ZD !!!}
                       => 0;
        endrecode;
        if valid then
          tcluster = i;
          { Enregistrer l'information dans le fichier pour cette ZD }
          t = writecase(Cluster_tracking_dict, tcluster); 
          if !t then 
            errmsg("Pas possible de creer le fichier de contrle de la ZD"); 
            break;
          endif;
        endif;
        i = i + 1;
      enddo;
      { reset value of tcluster---which may have changed above---to equal ecluster }
      tcluster = ecluster;
      close(Cluster_tracking_dict);
    endif;
    { Vrifier ce que veux faire l'utilisateur }
	startpos = accept("Voulez-vous:", 
  			  "1 Saisie date de reception et le nombre de ZD",
			  "2 Entrer code Agent de saisie", 
			  "3 Entrer code Agent verifieur");
    if startpos > 0 then { If user hits escape or cancel button, return to main menu }
      enter suivi_zd_ff;
      { contrlez la valeur du numro de la ZD }
      tcluster = ecluster;
      t = writecase(Cluster_tracking_dict, tcluster); 
      if !t then 
        errmsg("Pas possible d'ecrire l'information de controle concernant la grappe %03d",tcluster); 
      endif; 
    endif;
    close(Cluster_tracking_dict);
  endif;

      if choice =  0 then {ESC} reenter;          { sortie du menu & saisie d'un nouveau numro de ZD }
  elseif choice =  3 then {A} transfer(choice);   { Contrle de la structure             }
  elseif choice =  4 then {B} transfer(choice);   { Verification                         }
  elseif choice =  5 then {C} transfer(choice);	  { Sauvegarde Donnes brutes            }
  elseif choice =  6 then {---}                   { Ne rien faire                        }
  elseif choice =  7 then {D} csrun(choice);      { Edition                              }
  elseif choice =  8 then {E} csrun(choice);      { Modification des donnes             }
  elseif choice =  9 then {F} transfer(choice);	  { Sauvegarde des donnes finales Final }
  elseif choice =  10 then {---}                  { Ne rien faire                        }
  elseif choice =  11 then {G} transfer(choice);  { Exportion vers SPSS                  }
  elseif choice =  12 then {---}                  { Ne rien faire                        }
  elseif choice =  13 then {NEW} reenter;         { Nouveau numro de ZD                 }
  elseif choice =  14 then {NEW} csrun(choice);   { Imprimer info sur ZD                 }
  elseif choice =  15 then {QUIT}
    if fileexist(jstone) then
      filedelete(jstone);
    endif;
    stop(-1);       { quit the process }
  endif;
enddo;

PROC TRECVD
preproc 
if startpos <> 1 then
	advance TENTRYOPID;
endif;

PROC TRECVY
Preproc
TRECVY = 2010;
noinput;

Postproc
recode TRECVY  :     TRECVM         : TRECVD => err;
          2010 :       11           : 1-30 => 0;
          2010 :       12           : 1-31  => 0;
          2011 :       1            : 1-30 => 0;
               :                    :       => 1;
endrecode;
if err then
  errmsg("Date invalide");
  reenter
endif;
dd = (TRECVY*100 + TRECVM)*100 + TRECVD;
ss = sysdate("yyyymmdd");
if dd > ss then
  errmsg("Date reception impossible");
  reenter
endif;
PROC TNUMHHQUEST
if TNUMHHQUEST <> TNUMHHSEL then
	errmsg("Nombre de menages (%02d) n'est pas egal au nombre de menages selectionnes (%02d)", TNUMHHQUEST, TNUMHHSEL);
endif;
PROC TNUMHHCOMP
if (TNUMHHQUEST < TNUMHHCOMP) then
	errmsg("Nombre de menages completes (%02d) plus grand que le total des menages (%02d)", TNUMHHCOMP, TNUMHHQUEST);
	reenter;
endif;
PROC TENTRYOPID
preproc
if startpos <> 2 then
	advance TVENTRYOPID;
endif;

PROC TENTRYY
Preproc
TENTRYY = 2010;
noinput;

Postproc
if startpos = 2 then
	{ Only check date when we are entering it }
	recode TENTRYY  :     TENTRYM        : TENTRYD  => err;
              2010 :       11            : 1-30 => 0;
              2010 :       12            : 1-31  => 0;
              2011 :       1             : 1-30 => 0;
                   :                     :       => 1;
	endrecode;
	if err then
	  errmsg("Date invalide");
	  reenter
	endif;
	dd = (TENTRYY*100 + TENTRYM)*100 + TENTRYD;
	dr = (TRECVY*100 + TRECVM)*100 + TRECVD;
	ss = sysdate("yyyymmdd");
	if dd > ss or dd < dr then
	  errmsg("Date d'attribution avant date de reception or avant la date actuelle");
	  reenter
	endif;
	advance; 
endif;
PROC TVENTRYOPID
{ if verification entry has been assigned [TVENTRYOPID <> 0]
  and veri data entry operator equals main data entry operator [TVENTRYOPID = TENTRYOPID]}
if TVENTRYOPID <> 0 and TVENTRYOPID = TENTRYOPID then
	errmsg("Verification ne peut pas etre faite par le meme operateur qui a fait la saisie ");
	reenter;
endif;
PROC TVENTRYY
Preproc
TVENTRYY = 2010;
noinput;

Postproc
if startpos = 3 then
	{ Only check date when we are entering it }
	recode TVENTRYY  :     TVENTRYM        : TVENTRYD => err;
                2010 :       11            : 1-30 => 0;
                2010 :       12            : 1-31  => 0;
                2011 :       1             : 1-30 => 0;
                     :                     :       => 1;
	endrecode;
	if err then
	  errmsg("Date invalide");
	  reenter
	endif;
	dd = (TVENTRYY*100 + TVENTRYM)*100 + TVENTRYD;
	dr = (TRECVY*100 + TRECVM)*100 + TRECVD;
	de = (TENTRYY*100 + TENTRYM)*100 + TENTRYD;
	ss = sysdate("yyyymmdd");
	if dd > ss or dd < dr or dd < de then
	  errmsg("Date d'attribution avant date de reception ou  avant date de saisie ou avant date actuelle");
         reenter
	endif;
endif;
